# Generated by Django 3.2.9 on 2021-12-06 15:36

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import oauth2_provider.generators


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Throttle',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255)),
                ('throttling', models.CharField(help_text='Example: 100/day</br>Options: sec, min, hour, day, month, year', max_length=255)),
            ],
            options={
                'ordering': ['-id'],
            },
        ),
        migrations.CreateModel(
            name='Scope',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255)),
                ('key', models.CharField(help_text='View name, must match a valid name in View, see documentation.', max_length=255)),
                ('description', models.TextField(blank=True, help_text='Detailed Description for this scope you might want show to the user.', null=True)),
                ('admin_note', models.TextField(blank=True, null=True)),
                ('throttling', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='mad_oauth2.throttle')),
            ],
            options={
                'ordering': ['-id'],
            },
        ),
        migrations.CreateModel(
            name='Oauth2Application',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
                ('client_id', models.CharField(db_index=True, default=oauth2_provider.generators.generate_client_id, max_length=100, unique=True)),
                ('redirect_uris', models.TextField(blank=True, help_text='Allowed URIs list, space separated')),
                ('client_type', models.CharField(choices=[('confidential', 'Confidential'), ('public', 'Public')], max_length=32)),
                ('authorization_grant_type', models.CharField(choices=[('authorization-code', 'Authorization code'), ('implicit', 'Implicit'), ('password', 'Resource owner password-based'), ('client-credentials', 'Client credentials')], max_length=32)),
                ('client_secret', models.CharField(blank=True, db_index=True, default=oauth2_provider.generators.generate_client_secret, max_length=255)),
                ('name', models.CharField(blank=True, max_length=255)),
                ('skip_authorization', models.BooleanField(default=False)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('namespace', models.CharField(blank=True, max_length=255, null=True, unique=True)),
                ('allowed_schemes', models.TextField(blank=True, help_text='list of allowed schemes, seperated by new line.', null=True, verbose_name='Allowed Schemes')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('allowed_scopes', models.ManyToManyField(to='mad_oauth2.Scope')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='mad_oauth2_oauth2application', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'OAuth2 Application',
                'verbose_name_plural': 'OAuth2 Applications',
                'ordering': ['-id'],
                'abstract': False,
            },
        ),
    ]
